Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/CicularKernel.cs	(revision 15156)
@@ -29,17 +29,14 @@
   [Item("CircularKernel", "A circular kernel function 2*pi*(acos(-d)-d*(1-d²)^(0.5)) where n = ||x-c|| and d = n/beta \n  As described in http://crsouza.com/2010/03/17/kernel-functions-for-machine-learning-applications/")]
   public class CircularKernel : KernelBase {
-
-    #region HLConstructors & Boilerplate
     [StorableConstructor]
     protected CircularKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected CircularKernel(CircularKernel original, Cloner cloner) : base(original, cloner) { }
-    public CircularKernel() {
-    }
+
+    public CircularKernel() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new CircularKernel(this, cloner);
     }
-    #endregion
 
     protected override double Get(double norm) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/GaussianKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/GaussianKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/GaussianKernel.cs	(revision 15156)
@@ -31,17 +31,15 @@
   [Item("GaussianKernel", "A kernel function that uses Gaussian function exp(-n²/beta²). As described in http://crsouza.com/2010/03/17/kernel-functions-for-machine-learning-applications/")]
   public class GaussianKernel : KernelBase {
-
-    #region HLConstructors & Boilerplate
     [StorableConstructor]
     protected GaussianKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected GaussianKernel(GaussianKernel original, Cloner cloner) : base(original, cloner) { }
+
     public GaussianKernel() {
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new GaussianKernel(this, cloner);
     }
-    #endregion
 
     protected override double Get(double norm) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/InverseMultiquadraticKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/InverseMultiquadraticKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/InverseMultiquadraticKernel.cs	(revision 15156)
@@ -29,17 +29,16 @@
   [Item("InverseMultiquadraticKernel", "A kernel function that uses the inverse multi-quadratic function  1 / sqrt(1+||x-c||²/beta²). Similar to http://crsouza.com/2010/03/17/kernel-functions-for-machine-learning-applications/ with beta as a scaling factor.")]
   public class InverseMultiquadraticKernel : KernelBase {
+    private const double C = 1.0;
 
-    private const double C = 1.0;
-    #region HLConstructors & Boilerplate
     [StorableConstructor]
     protected InverseMultiquadraticKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected InverseMultiquadraticKernel(InverseMultiquadraticKernel original, Cloner cloner) : base(original, cloner) { }
+
     public InverseMultiquadraticKernel() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new InverseMultiquadraticKernel(this, cloner);
     }
-    #endregion
 
     protected override double Get(double norm) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/KernelBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/KernelBase.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/KernelBase.cs	(revision 15156)
@@ -32,8 +32,6 @@
   public abstract class KernelBase : ParameterizedNamedItem, IKernel {
 
-    #region Parameternames
     private const string DistanceParameterName = "Distance";
-    #endregion
-    #region Parameterproperties
+
     public ValueParameter<IDistance> DistanceParameter {
       get { return Parameters[DistanceParameterName] as ValueParameter<IDistance>; }
@@ -42,6 +40,5 @@
     [Storable]
     public double? Beta { get; set; }
-    #endregion
-    #region Properties
+
     public IDistance Distance {
       get { return DistanceParameter.Value; }
@@ -49,10 +46,6 @@
     }
 
-    #endregion
-
     [StorableConstructor]
     protected KernelBase(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
 
     protected KernelBase(KernelBase original, Cloner cloner)
@@ -82,5 +75,5 @@
     public ParameterizedCovarianceFunction GetParameterizedCovarianceFunction(double[] p, int[] columnIndices) {
       if (p.Length != GetNumberOfParameters(columnIndices.Length)) throw new ArgumentException("Illegal parametrization");
-      var myClone = (KernelBase)Clone(new Cloner());
+      var myClone = (KernelBase)Clone();
       myClone.SetParameter(p);
       var cov = new ParameterizedCovarianceFunction {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/MultiquadraticKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/MultiquadraticKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/MultiquadraticKernel.cs	(revision 15156)
@@ -32,18 +32,17 @@
 
     private const double C = 1.0;
-    #region HLConstructors & Boilerplate
+
     [StorableConstructor]
     protected MultiquadraticKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected MultiquadraticKernel(MultiquadraticKernel original, Cloner cloner)
                 : base(original, cloner) { }
 
-    public MultiquadraticKernel() {
-    }
+    public MultiquadraticKernel() { }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new MultiquadraticKernel(this, cloner);
     }
-    #endregion
+
     protected override double Get(double norm) {
       var beta = Beta.Value;
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/PolysplineKernel.cs	(revision 15156)
@@ -33,31 +33,26 @@
   public class PolysplineKernel : KernelBase {
 
-    #region Parameternames
     private const string DegreeParameterName = "Degree";
-    #endregion
-    #region Parameterproperties
+
     public IFixedValueParameter<DoubleValue> DegreeParameter {
       get { return Parameters[DegreeParameterName] as IFixedValueParameter<DoubleValue>; }
     }
-    #endregion
-    #region Properties
+
     public DoubleValue Degree {
       get { return DegreeParameter.Value; }
     }
-    #endregion
 
-    #region HLConstructors & Boilerplate
     [StorableConstructor]
     protected PolysplineKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected PolysplineKernel(PolysplineKernel original, Cloner cloner) : base(original, cloner) { }
+
     public PolysplineKernel() {
       Parameters.Add(new FixedValueParameter<DoubleValue>(DegreeParameterName, "The degree of the kernel. Needs to be greater than zero.", new DoubleValue(1.0)));
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PolysplineKernel(this, cloner);
     }
-    #endregion
 
     protected override double Get(double norm) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelFunctions/ThinPlatePolysplineKernel.cs	(revision 15156)
@@ -33,31 +33,25 @@
   public class ThinPlatePolysplineKernel : KernelBase {
 
-    #region Parameternames
     private const string DegreeParameterName = "Degree";
-    #endregion
-    #region Parameterproperties
+
     public IFixedValueParameter<DoubleValue> DegreeParameter {
       get { return Parameters[DegreeParameterName] as IFixedValueParameter<DoubleValue>; }
     }
-    #endregion
-    #region Properties
     public DoubleValue Degree {
       get { return DegreeParameter.Value; }
     }
-    #endregion
 
-    #region HLConstructors & Boilerplate
     [StorableConstructor]
     protected ThinPlatePolysplineKernel(bool deserializing) : base(deserializing) { }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
+
     protected ThinPlatePolysplineKernel(ThinPlatePolysplineKernel original, Cloner cloner) : base(original, cloner) { }
+
     public ThinPlatePolysplineKernel() {
       Parameters.Add(new FixedValueParameter<DoubleValue>(DegreeParameterName, "The degree of the kernel. Needs to be greater than zero.", new DoubleValue(2.0)));
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new ThinPlatePolysplineKernel(this, cloner);
     }
-    #endregion
 
     protected override double Get(double norm) {
Index: trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegression.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegression.cs	(revision 14936)
+++ trunk/sources/HeuristicLab.Algorithms.DataAnalysis/3.4/KernelRidgeRegression/KernelRidgeRegression.cs	(revision 15156)
@@ -107,6 +107,4 @@
       Parameters.Add(new FixedValueParameter<DoubleValue>(BetaParameterName, "The beta parameter for the kernel", new DoubleValue(2)));
     }
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() { }
 
     public override IDeepCloneable Clone(Cloner cloner) {